 import java.awt.*;
 import javax.swing.*;
 import java.util.*;
 import java.io.*;
 import java.net.*;
 class BouncePanel extends JPanel
 {
   Image myImage,image1,image2,riverimage1,riverimage2,boat,road,grass;
   public int x1,y1=150,x2,y2,oldx2,oldy2;
   //public String value=new String();
   private Socket CommunicatingSocket=null;
   String InputFromClient, lastInput; 
   ArrayList images;
   LinkedHashMap locations;
   
   BouncePanel() throws Exception
   {
     super();
     setSize(1024,768);
     images = new ArrayList();
     locations = new LinkedHashMap();
     //Toolkit kit = Toolkit.getDefaultToolkit();
     //myImage = kit.getImage("car.jpg");
     //myImage1=kit.getImage("Car1.jpg");
   }
   public void paintComponent(Graphics g) 
   {    riverimage1 = new ImageIcon("river1.jpg").getImage();
   		riverimage2 = new ImageIcon("river2.jpg").getImage();
		road = new ImageIcon("road.jpg").getImage();
		boat = new ImageIcon("boat.jpg").getImage();
		//grass = new ImageIcon("Grass.jpg").getImage();
   	    g.setColor(Color.green);
   	    g.fillRect(0,0,this.getWidth(),this.getHeight());
		g.drawImage(grass,0,0,this);
   	    g.setColor(Color.GRAY);
   	    g.fillRect(0,260,1024,100);
		g.drawImage(road,0,260,this);
   	    g.setColor(Color.GRAY);
   	    g.fillRect(250,0,100,280);
   	    g.fillRect(250,340,100,360);
		g.drawImage(riverimage1,250,0,this);
		g.drawImage(riverimage2,250,340,this);
		g.drawImage(boat,260,40,this);
		g.drawImage(boat,270,500,this);
   	    image1=new ImageIcon("gate1.jpg").getImage();
   	    g.drawImage(image1,540,260,this);
		g.setColor(Color.blue);
		g.drawString("TollGate",530,380);
   	    image2=new ImageIcon("checkpost.jpg").getImage();
   	    g.drawImage(image2,740,260,this);
		g.drawString("CheckPost",730,380);
   	    g.setColor(Color.green);
   	    if(lastInput!=null)
   	    	g.drawString(lastInput,500,500);

	    g.setColor(Color.red);
   	  //if(value.equals("c"))
   	  //{
   	    //g.drawString(InputFromClient+"   "+x1+"  "+y1+"  "+x2+"   "+y2,200,200);
   	    if(InputFromClient!=null)
   	    	g.drawString(InputFromClient,500,500);
   	    //g.drawImage(myImage1,x1*10,y1,this);
   	    g.setColor(Color.DARK_GRAY);
   	 //   System.out.println(oldx2 + "," + oldy2);
   	    //g.fillRect(oldx2*10,oldy2,40,50);
   	    Iterator i_images = images.iterator();
   	    Set entries = locations.entrySet();
   	    Iterator i_locations = entries.iterator();
   	    while(i_locations.hasNext()) {
   	    	Map.Entry entry1 = (Map.Entry)i_locations.next();
   	    	String con = (String)entry1.getKey();
   	    	String pos = (String)entry1.getValue();
   	    	myImage = (Image)i_images.next();
   	    	
   	    	StringTokenizer st = new StringTokenizer(pos,",");
   	    	oldx2 = Integer.parseInt(st.nextToken());
   	    	oldy2 = Integer.parseInt(st.nextToken());
   	    	//x2 = Integer.parseInt(st.nextToken());
   	    	//y2 = Integer.parseInt(st.nextToken());
   	    //	g.fillRect(oldx2*20,oldy2+290,50,17);
   	    	//g.drawImage(myImage,x2*10,y2,40,50,this);
   	    }


   	    i_images = images.iterator();
   	    entries = locations.entrySet();
   	    i_locations = entries.iterator();
   	    while(i_locations.hasNext()) {
   	    	Map.Entry entry1 = (Map.Entry)i_locations.next();
   	    	String con = (String)entry1.getKey();
   	    	String pos = (String)entry1.getValue();
   	    	myImage = (Image)i_images.next();
   	    	
   	    	StringTokenizer st = new StringTokenizer(pos,",");
   	    	oldx2 = Integer.parseInt(st.nextToken());
   	    	oldy2 = Integer.parseInt(st.nextToken());
   	    	x2 = Integer.parseInt(st.nextToken());
   	    	y2 = Integer.parseInt(st.nextToken());
   	    	//g.fillRect(oldx2*10,oldy2,40,50);
   	    	g.drawImage(myImage,x2*20,y2+290,50,17,this);
   	    }
      //}
  	  /*else if(value.equals("p"))
   	  {
   	    g.drawString(InputFromClient+"   "+x2*10+"  "+y2,200,200);
   	    //g.drawImage(myImage1,x1*10,y1,this);   	    
   	    g.drawImage(myImage,x2*10,y2,25,100,this);
      }*/
  }
 }
 public class BounceFrame extends JFrame
 {
 	BouncePanel bp;
 	public BounceFrame() 
 	{
      super("LogicFence");
      setSize(1024,768);
      setDefaultCloseOperation(JFrame.EXIT_ON_CLOSE);
      try
      {
         BouncePanel boing = new BouncePanel();
         Container pane = getContentPane();
         pane.add(boing);
         bp = boing;
         setContentPane(pane);
         setVisible(true);
       }
       catch(Exception e)
       {
       }
    }
   public static void main(String[] arguments) throws Exception
   {
     ServerSocket welcomeSocket=new ServerSocket(6789);
     BounceFrame frame = new BounceFrame();
     frame.setBackground(Color.black);
     int con = 0;
     while (true)
     {
     	     con++;
     	     Socket CommunicatingSocket = welcomeSocket.accept();     
			 ServerThread st = new ServerThread(CommunicatingSocket,frame, con);
			 st.start();
		   //  System.out.println("Connection created");
     }
     
   }
 }
 
class ServerThread extends Thread
{
	private Socket incoming;
	private BounceFrame frame;
    private String InputFromClient=""; 
	//public int oldx,oldy;
	Image image;
	BufferedReader br;
	int msgcount = 0;
	int con;
	ServerThread(Socket i, BounceFrame bouncef, int con_no)
	{
		incoming = i;
		frame = bouncef;
		con = con_no;
		//br = new BufferedReader(new InputStreamReader(incoming.getInputStream()));
    }
   public void run()
   {
   //	System.out.println("In Run");
    int xcor=0,ycor=0;
    frame.bp.x2 = xcor;
    frame.bp.y2 = ycor;
    String value=new String();
    BufferedReader br=null;
    try
    {
      br=new BufferedReader(new InputStreamReader(incoming.getInputStream()));     	   	     
    }
    catch(Exception e)
    { 
       e.printStackTrace();
    } 
    while(InputFromClient!=null) 
    { 
	   frame.bp.repaint();
	   try
	   {
	   	InputFromClient = br.readLine(); 
	   	msgcount++;
	   	System.out.println(InputFromClient);
        if(InputFromClient!=null) {
        StringTokenizer st = new StringTokenizer(InputFromClient,"(,) ");
        frame.bp.oldx2 = xcor;
        frame.bp.oldy2 = ycor;
        xcor =Integer.parseInt(st.nextToken());
        ycor =Integer.parseInt(st.nextToken());
        String positions = Integer.toString(frame.bp.oldx2) + "," + Integer.toString(frame.bp.oldy2) + "," + Integer.toString(xcor) + "," + Integer.toString(ycor);
		frame.bp.locations.put(Integer.toString(con),positions);
		value=st.nextToken();
		}
        System.out.println(xcor);
        System.out.println(ycor);
     //   System.out.println(value);
	   	if(value.equals("c") && msgcount==1) 
	   	{
		     Toolkit kit = Toolkit.getDefaultToolkit();
   		     image = kit.getImage("car.jpg");
   		     frame.bp.images.add(image);
	   	}
	   	if(value.equals("p") && msgcount==1) 
	   	{
		     Toolkit kit = Toolkit.getDefaultToolkit();
   		     image = kit.getImage("policecar.jpg");
   		     frame.bp.images.add(image);
	   	}
          frame.bp.x2 = xcor;
          frame.bp.y2 = ycor;
          frame.bp.myImage = image;
          frame.bp.lastInput = frame.bp.InputFromClient;
          frame.bp.InputFromClient = InputFromClient;
  	   }
	   catch(IOException ioe)
       {
      	 InputFromClient = null;
      	 ioe.printStackTrace();
       }
	   catch(Exception e)
       {
      	 e.printStackTrace();
       }
     }
    try
    {
    	if(incoming!=null)
    		incoming.close();
    	frame.bp.locations.remove(Integer.toString(con));
    	frame.bp.images.remove(image);
    	frame.bp.repaint();
    }
    catch(Exception e)
    { 
       e.printStackTrace();
    } 
   }
}
