import java.sql.*;
import java.io.*;

/*Initial setup:

1. Make an entry of start state in DB for start state and open log.txt.

2. Generate an appId for an application and keep a centralized access to it. When the 

application terminates, remove the appId for further reuse(to be added for shutdown thread).
Initialise IdList/appId.

3. add ShutDownHook to the program.*/

class Settings {
	static Statement s;
	static int initialise(String startState) {
		//IdList.appId = 1;  // neeeds to be generated from a centralized DB
		
		try {
			ChkStSpace.bw=new BufferedWriter(new FileWriter("log.txt"));
			ChkStSpace.connectToDb();
			s = ChkStSpace.conn.createStatement();
			//ResultSet res=s.executeQuery("LOCK TABLE appl_ids WRITE");
			ResultSet res=s.executeQuery("start transaction");
			
			res = s.executeQuery("select appl_id from appl_ids order by appl_id for update");
			int i = 1;
			//int newid = i;
			while(res.next()) {
				int id = res.getInt(1);
				if(id==i)
					i++;
				else {
					//newid = i;
					break;
				}
			}
			//newid = i;  // line
			//System.out.println("DB connected");
			s.executeUpdate("insert into appl_ids values ("+i+")");
			 
			//res=s.executeQuery("UNLOCK TABLES");
			IdList.appId = i;

			int rs=s.executeUpdate("update state_tabl set no_of_applications=no_of_applications+1 where statename=\""+startState+"\"");
			s.executeUpdate("insert into property_tabl(appl_id,statename) values ("+IdList.appId+",\""+startState+"\");");
			res=s.executeQuery("commit");
			ChkStSpace.lastState = startState;
		}
		catch (Exception e)
		{
			System.out.println("Settings: DB error");
			try {
			ResultSet res=s.executeQuery("rollback");
		}catch (Exception ee){}
			return 0;
		}

		Runtime.getRuntime().addShutdownHook(ChkStSpace.shutdownActions);
		return 1;
	}
}