open (INFILE,"outputStateDefs.xml");
open (OUTFILE,">determineFutOutState.java");
print  OUTFILE "static String determineFutOutState(String value){\n";
@inpfile=<INFILE>;
close INFILE;
$currState = "";
$futState = "";
$regVars = "String ";
$ptrnVars = "Pattern ";
$mtchrVars = "Matcher ";
$count = 0;
$findstmt = "";
@allRegex = ();
@allPattern = ();
foreach $line(@inpfile) {
    if($line =~ /<current>(.+)<\/current>/) {
	$currState = $1;
	$findstmt = "\n	   if(lastState.equals(\"$1\") ";
    }
    if($line =~ /<output type=(.+)>(.+)<\/output>/) {
	$count++;
	if($count==1) {
	    $regVars = $regVars." REGEX$count=\"\"";
	    $ptrnVars = $ptrnVars." pattern$count";
	    $mtchrVars = $mtchrVars." matcher$count";
	}
	else {
	    $regVars = $regVars.", REGEX$count=\"\"";
	    $ptrnVars = $ptrnVars.", pattern$count";
	    $mtchrVars = $mtchrVars.", matcher$count";
	}
        $allRegex[$count-1] = $2;

	if($1 eq ("yes")) {  # form the find() statement
		$findstmt = $findstmt."&& matcher$count.find() ";
		$allPattern[$count-1] = "pattern".($count)." = Pattern.compile(REGEX".($count).");"
	}
	elsif($1 eq ("yes_db")) {  # form the find() statement
		$findstmt = $findstmt."&& matcher$count.find() ";
		$allPattern[$count-1] = "pattern".($count)." = Pattern.compile(REGEX".($count).", java.util.regex.Pattern.CASE_INSENSITIVE);"
	}
	elsif($1 eq ("no_db")) {  # form the find() statement
		$findstmt = $findstmt."&& !matcher$count.find() ";
		$allPattern[$count-1] = "pattern".($count)." = Pattern.compile(REGEX".($count).", java.util.regex.Pattern.CASE_INSENSITIVE);"
	}
	else {
		$findstmt = $findstmt."&& !matcher$count.find() ";
		$allPattern[$count-1] = "pattern".($count)." = Pattern.compile(REGEX".($count).");"
	}
    }
    if($line =~ /<future>(.+)<\/future>/) {
        $futState = $1;
    }
    if($line =~ /<\/State>/) {
        print OUTFILE "\n   {
	$regVars;
	$ptrnVars;
	$mtchrVars;";
	for($i=0;$i<$count;$i++) {  # write the Pattern.compile statements and matcher statements.
	   print OUTFILE "\n\n	   REGEX".($i+1)." = \"".$allRegex[$i]."\";
	   $allPattern[$i]
	   matcher".($i+1)." = pattern".($i+1).".matcher(value.trim());";
	}
	print OUTFILE "\n$findstmt) {
		   return \"$futState\";\n	   }\n	}\n";
	$currState = "";
	$futState = "";
	$regVars = "String ";
	$ptrnVars = "Pattern ";
	$mtchrVars = "Matcher ";
	$count = 0;
	$findstmt = "";
	@allRegex = ();
	@allPattern = ();
    }
}
print OUTFILE "\nreturn(lastState);
}";
close OUTFILE;